#include <stdio.h>
#include "targetdev.h"
#include "uart_transfer.h"


#define PLLCON_SETTING  		CLK_PLLCTL_160MHz_HIRC
#define PLL_CLOCK       		160000000
#define HCLK_DIV 			    1
#define APROM_252K              0x3F000

//typedef void (FUNC_PTR)(void);
extern uint32_t g32_lcmd; 
__attribute__((at(APROM_252K))) const uint32_t APROM252K_ConnectTag = 0xFFFFFFFF; 
__attribute__((at(APROM_252K+4))) const uint32_t APROM252K4_ResetTag = 0xFFFFFFFF; 

/*
 *  Set stack base address to SP register.
 */
 
//#ifdef __ARMCC_VERSION                 /* for Keil compiler */
//__asm __set_SP(uint32_t _sp)
//{
//    MSR MSP, r0
//    BX lr
//}
//#endif

uint32_t CLK_GetPLLClockFreq(void)
{
    return PLL_CLOCK;
}
void SYS_Init(void)
{
    /* Enable Internal and External RC clock */
    CLK->PWRCTL |= PLLCON_SETTING;

    /* Waiting for Internal RC clock ready */
    while (!(CLK->STATUS & CLK_STATUS_HIRCSTB_Msk));

    /* Set core clock as PLL_CLOCK from PLL */
    CLK->PLLCTL = PLLCON_SETTING;

    while (!(CLK->STATUS & CLK_STATUS_PLLSTB_Msk));

    CLK->CLKSEL0 = (CLK->CLKSEL0 & (~CLK_CLKSEL0_HCLKSEL_Msk)) | CLK_CLKSEL0_HCLKSEL_PLL;
    CLK->CLKDIV0 &= ~CLK_CLKDIV0_HCLKDIV_Msk;
    CLK->CLKDIV0 |= CLK_CLKDIV0_HCLK(HCLK_DIV);
    /* Update System Core Clock */
    /* User can use SystemCoreClockUpdate() to calculate PllClock, SystemCoreClock and CycylesPerUs automatically. */
    //SystemCoreClockUpdate();
    PllClock        = PLL_CLOCK;            			// PLL
    SystemCoreClock = PLL_CLOCK / HCLK_DIV;				// HCLK
    CyclesPerUs     = SystemCoreClock / 1000000;  // For SYS_SysTickDelay()
    /* Enable UART module clock */
    CLK->APBCLK0 |= CLK_APBCLK0_UART0CKEN_Msk;
    /* Select UART module clock source */
    CLK->CLKSEL1 &= ~CLK_CLKSEL1_UART0SEL_Msk;
    CLK->CLKSEL1 |= CLK_CLKSEL1_UART0SEL_HIRC;
    /*---------------------------------------------------------------------------------------------------------*/
    /* Init I/O Multi-function                                                                                 */
    /*---------------------------------------------------------------------------------------------------------*/
    /* Set GPB multi-function pins for UART0 RXD and TXD */
    SYS->GPB_MFPH &= ~(SYS_GPB_MFPH_PB12MFP_Msk | SYS_GPB_MFPH_PB13MFP_Msk);
    SYS->GPB_MFPH |= (SYS_GPB_MFPH_PB12MFP_UART0_RXD | SYS_GPB_MFPH_PB13MFP_UART0_TXD);
}

int32_t FMC_Erase(uint32_t u32PageAddr)
{
    int32_t  ret = 0;

    if (ret == 0)
    {
        FMC->ISPCMD = FMC_ISPCMD_PAGE_ERASE;
        FMC->ISPADDR = u32PageAddr;
        FMC->ISPTRG = FMC_ISPTRG_ISPGO_Msk;

        while (FMC->ISPTRG & FMC_ISPTRG_ISPGO_Msk) { }

        if (FMC->ISPCTL & FMC_ISPCTL_ISPFF_Msk)
        {
            FMC->ISPCTL |= FMC_ISPCTL_ISPFF_Msk;
            ret = -1;
        }
    }
    return ret;
}
void FMC_Write(uint32_t u32Addr, uint32_t u32Data)
{
    FMC->ISPCMD = FMC_ISPCMD_PROGRAM;
    FMC->ISPADDR = u32Addr;
    FMC->ISPDAT = u32Data;
    FMC->ISPTRG = FMC_ISPTRG_ISPGO_Msk;
    while (FMC->ISPTRG & FMC_ISPTRG_ISPGO_Msk) { }
}
/*---------------------------------------------------------------------------------------------------------*/
/* MAIN function                                                                                           */
/*---------------------------------------------------------------------------------------------------------*/

int main(void)
{
    int i_cnt=0;
    int connect_flag=0;
//    FUNC_PTR    *func;                 /* function pointer */
//    uint32_t    u32data=0;               /* flash data    */
    uint32_t    led_delay=0;
    /* Unlock protected registers */
    SYS_UnlockReg();
    /* Init System, peripheral clock and multi-function I/O */
    SYS_Init();
    /* Init UART to 115200-8n1 */
    UART_Init();
    CLK->AHBCLK |= CLK_AHBCLK_ISPCKEN_Msk;
    FMC->ISPCTL |= FMC_ISPCTL_ISPEN_Msk;
    g_apromSize = GetApromSize();
    GetDataFlashInfo(&g_dataFlashAddr, &g_dataFlashSize);
    SysTick->LOAD = 300000 * CyclesPerUs;
    SysTick->VAL   = (0x00);
    SysTick->CTRL = SysTick->CTRL | SysTick_CTRL_CLKSOURCE_Msk | SysTick_CTRL_ENABLE_Msk;//using cpu clock
SYS->GPH_MFPL &= ~(SYS_GPH_MFPL_PH0MFP_Msk | SYS_GPH_MFPL_PH1MFP_Msk | SYS_GPH_MFPL_PH2MFP_Msk);
GPIO_SetMode(PH, (BIT0|BIT1|BIT2), GPIO_MODE_OUTPUT);
    
    while (1) {
        if ((bufhead >= 4) || (bUartDataReady == TRUE)) {
            uint32_t lcmd;
            lcmd = inpw(uart_rcvbuf);

            if (lcmd == CMD_CONNECT) {
                goto _ISP;
            } else {
                bUartDataReady = FALSE;
                bufhead = 0;
            }
        }

        PH0 = 0;
        PH1 = 0;
        PH2 = 0;
        for(led_delay=0;led_delay<300000;led_delay++);
        for(led_delay=0;led_delay<300000;led_delay++);
        PH0 = 1;
        PH1 = 1;
        PH2 = 1;        
        for(led_delay=0;led_delay<300000;led_delay++);
        for(led_delay=0;led_delay<300000;led_delay++);        
        
    }

_ISP:
    while (1) {
        
        if (bUartDataReady == TRUE) {
            bUartDataReady = FALSE;
            ParseCmd(uart_rcvbuf, 64);
            PutString();
            if(g32_lcmd == CMD_GET_DEVICEID)   //jump to LDROM
                connect_flag=1;
            if(connect_flag) 
                i_cnt++;
            if(i_cnt >= 2)   //jump to LDROM
            {
                SYS_UnlockReg();                   /* Unlock register lock protect */
                FMC->ISPCTL |=  FMC_ISPCTL_ISPEN_Msk;                        /* Enable FMC ISP function */
                FMC->ISPCTL |=  FMC_ISPCTL_APUEN_Msk;            /* Enable APROM update. */
                FMC_Erase(APROM_252K);
//                u32data = FMC_Read(APROM_252K);
                FMC_Write(APROM_252K, 0x00000000);
                
//                /* FMC_SetVectorPageAddr(FMC_LDROM_BASE) */
//                FMC->ISPCMD = FMC_ISPCMD_VECMAP;              /* ISP command */
//                FMC->ISPADDR = FMC_LDROM_BASE;                /* Vector remap address */
//                FMC->ISPTRG = FMC_ISPTRG_ISPGO_Msk;           /* Trigger ISP command */
//                while (FMC->ISPTRG & FMC_ISPTRG_ISPGO_Msk) ;  /* Wait for ISP command done. */
//                func = (FUNC_PTR *)*(uint32_t *)(FMC_LDROM_BASE + 4);
//#ifdef __GNUC__                        /* for GNU C compiler */
//                u32Data = *(uint32_t *)FMC_LDROM_BASE;
//                asm("msr msp, %0" : : "r" (u32Data));
//#else
//                __set_SP(*(uint32_t *)FMC_LDROM_BASE);
//#endif
//                func();
        
                SYS->RSTSTS = (SYS_RSTSTS_PORF_Msk | SYS_RSTSTS_PINRF_Msk);
//                FMC->ISPCTL &= ~(FMC_ISPCTL_ISPEN_Msk | FMC_ISPCTL_BS_Msk);
                FMC->ISPCTL = ((FMC->ISPCTL & ~(FMC_ISPCTL_ISPEN_Msk)) | FMC_ISPCTL_BS_Msk);
//                FMC->ISPCTL  = FMC->ISPCTL | FMC_ISPCTL_BS_Msk;
                SCB->AIRCR = (V6M_AIRCR_VECTKEY_DATA | V6M_AIRCR_SYSRESETREQ);                
            }
        }
    }
}
